#include "cMission.h"

#include "main.h"


cObject* cTestMission::init(cWorld* world) {
    world->mBackground = new cDome;
    
    if (true) {
        world->mTime = 12.00f;
    } else {
        float hour;
        getSystemHour(hour);
        world->mTime = hour;
    }
    
    player = initMechs(world);
    initArchitecture(world);
    initFlora(world);
    return player;
}


void cTestMission::onFrag(cObject* fragged) {
    // Nothing great yet.
    if (fragged == player) {
        printf("You Lost!\n");
    } else if (fragged == primary) {
        printf("You Won!\n");
    }
}


cObject* cTestMission::initMechs(cWorld* planet) {
    cObject* player = NULL;
    
    if (true) {
        float pos[3] = { -50, 0, -50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad;
        mech->mName = new string("Alpha");

        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->mRoles |= (1UL<<cObject::RED) | (1UL<<cObject::HUMANPLAYER);
        mech->mEnemies |= (1UL<<cObject::BLUE);
        
        player = mech;
        
        //cController* ai = new cController;
        //ai->newState(cController::TARGET, "Delta");
        //mech->mController = ai;
        
        planet->spawnObject(mech);
        
        if (true) {
            
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*)"LTorsor", new cPlasmaGun);
            mech->mountWeapon((char*)"RTorsor", new cPlasmaGun);
            mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
            mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
            mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RLoArm",  new cHomingMissile);
        }
    }
#if 0
    for (int i = 0; i < 30; i++) {
        float pos[3] = { (i%6) * 10 - 50, 0, 20 + (i/6)*10 + (i/6%2)*5 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = new string("X");
        
        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);

        //ai->newState(cControllerI::TARGET, "Charly");
        //ai->newState(cController::ROUTE, "Attackroute");
        
        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
            mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
        }
    }

    for (int i = 0; i < 30; i++) {
        float pos[3] = { (i%6) * 10 - 50, 0, -20 + (i/6)*10 + (i/6%2)*5 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = new string("Y");
        
        mech->mRoles |= (1UL<<cObject::RED);
        mech->mEnemies |= (1UL<<cObject::BLUE);

        //ai->newState(cControllerI::TARGET, "Charly");
        //ai->newState(cController::ROUTE, "Attackroute");
        
        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RTorsor",  new cSparkGun);
            mech->mountWeapon((char*)"LTorsor",  new cRaybeam);
        }
    }
#endif
    
    if (true) {
        float pos[3] = { +50, 0, -50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = new string("Bravo");
        
        mech->mRoles |= (1UL<<cObject::RED);
        mech->mEnemies |= (1UL<<cObject::BLUE);

        //ai->newState(cControllerI::TARGET, "Charly");
        //ai->newState(cController::ROUTE, "Attackroute");
        
        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
            mech->mountWeapon((char*)"LTorsor",  new cHomingMissile);
        }
    }
    
    
    if (true) {
        float pos[3] = { +50, 0, +50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = new string("Charly");
        
        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);

        //ai->newState(cController::WAIT, (char*) NULL);
        //ai->newState(cController::TARGET, "Delta");
        //ai->newState(cController::ROUTE, "Attackroute");
        
        primary = mech;
        
        planet->spawnObject(mech);
        
        if (true) {
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            mech->mountWeapon((char*)"RLoArm",  new cSparkGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }
    
    
    if (true) {
        float pos[3] = { -50, 0, +50 };
        cMech* mech = new cMech(pos);
        assert(mech != NULL);
        
        mech->mPad = new cPad();
        mech->mName = new string("Delta");

        mech->mRoles |= (1UL<<cObject::BLUE);
        mech->mEnemies |= (1UL<<cObject::RED);
        
        //ai->newState(cController::ENGAGE, "Charly");
        //ai->newState(cController::ROUTE, navs);
        
        //gCameraEntity = mech;
        planet->spawnObject(mech);
        
        if (true) {
            mech->mountWeapon((char*)"LLoArm",  new cSparkGun);
            //mech->mountWeapon((char*)"LLoArm",  new cRaybeam);
            //mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
            mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }
    
    return player;
}


void cTestMission::initArchitecture(cWorld* planet) {
    if (!true) {
        int bld_dist = 50;
        cBuilding* bld;
        for (int i=0; i<3; i++) {
            for (int j=0; j<3; j++) {
                if (!((i==1) && (j==1))) {
                    float pos[3] = {
                        i*bld_dist*2-bld_dist,
                        0,
                        j*bld_dist*2-bld_dist
                    };
                    bld = new cBuilding(pos);
                    planet->spawnObject(bld);
                };
            };
        };
    }
}


void cTestMission::initFlora(cWorld* planet) {
       
    struct plantplan {
        int n, seed, type, age;
    } pp[] = {
        {  16, 1234, 0, 3 },
        {   8, 1234, 1, 2 },
        {   4, 1234, 2, 3 },
        {   2, 1234, 0, 4 },
        {   3, 1234, 1, 5 },
    };
    
    int dist = 320;

    for (int j = 0; j < sizeof(pp)/sizeof(plantplan); j++) {
        for (int i=0; i<pp[j].n; i++) {
            float a = rand()%360;
            float b = rand() % (2*dist);
            float pos[3] = { sin(a*0.017454)*b, 0, cos(a*0.017454)*b };
            float rot[3] = { 0, 10*(rand()%36), 0 };
            planet->spawnObject(new cTree(pos, rot, pp[j].seed, pp[j].type, pp[j].age));
        };        
    }
    
}


